/***************************************************************************
 *                          Zanoza Modeler v2.x                            *
 *      This is unpublished propietary source code of Zanoza Software.     *
 *      The copyright notice does not evidence any actual or intended      *
 *                    publication of such source code.                     *
 *                                                                         *
 *                Copyright (c) 2002-2003 Zanoza Software.                 *
 *                                                                         *
 *                        All rights reserved.                             *
 ***************************************************************************
 *--------------------------------------------------------------------------
 * @author:   Oleg M.
 *--------------------------------------------------------------------------
 * @purpose:  ZModeler 2.x Create\Light\Strip tool implementation
 *--------------------------------------------------------------------------
 * @histroy: 17.09.2003. Created
 */
#include "Spline.h"
#include "SplineNode.h"
#include "CreateSpline.h"
#include <zmsharedclasses.h>
#include <helpers/services.h>

namespace core
{
namespace tools
{
BOOL CWeldDialog::OnInitDialog()
{
  // sizing stuff
  ZPtr<services::IDialogSizingService>  pDSS;
  if (ZRESULT_OK == services::getDialogSizingService(&pDSS))
  {
    pDSS->setDialog(this, ZRect(0, 0, 50, 20), true, false);
    pDSS->addControl(IDC_PRECISIONTEXT, DSS_HORIZONTAL(DSS_23_SCALE(DSS_SIZE)));
    pDSS->addControl(IDC_PRECISION,     DSS_HORIZONTAL(DSS_23_SCALE(DSS_MOVE) | DSS_3_SCALE(DSS_SIZE)));
  }
  createSharedClass(_T(ZM_CLASS_SPIN_CONTROL), IID_(core::ui::controls::ISpinControl), (void**)&m_pSpin);
  if (m_pSpin)
  {
    m_pSpin->embed(GetDlgItem(IDC_PRECISION));
    m_pSpin->setPrecision(INT(log10((float)PRECISION)));
    m_pSpin->setRange(0*PRECISION, 10*PRECISION);
    m_pSpin->setValue(INT(0.1f*PRECISION));
  }
  return CChildDialog::OnInitDialog();
}

float CWeldDialog::getThreshold()
{
  long n;
  if (m_pSpin)
    m_pSpin->getValue(n);
  else
    return 0.0f;
  return (float)n/(float)PRECISION;
}

BOOL CWeldModeDialog::OnInitDialog()
{
  ((CButton*)GetDlgItem(IDC_STOPSTART))->SetCheck(1);
  return CChildDialog::OnInitDialog();
}

bool CWeldModeDialog::continueSpline()
{
  getResult();
  return (m_nChoice == IDC_CONTINUE);
}

bool CWeldModeDialog::stopStartSpline()
{
  getResult();
  return (m_nChoice == IDC_STOPSTART);
}

void CWeldModeDialog::getResult()
{
  m_nChoice = 0;
  if (((CButton*)GetDlgItem(IDC_CONTINUE))->GetCheck() == 1)
    m_nChoice = IDC_CONTINUE;
  else
    m_nChoice = IDC_STOPSTART;
}



};//tools
};//core

